"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.customtags = exports.htmltagsExtendsBluekeys = exports.jsVariables = exports.methodVariables = exports.greenVariables = exports.pinkKeywords = exports.blueKeywords = exports.nonBreakingCharacters = exports.lslash = exports.gt = exports.ls = exports.replacerIdentifiers = void 0;
var global_1 = require("./global");
var ids = 8765;
exports.replacerIdentifiers = {
    string: (0, global_1.getCharacter)(ids++),
    comment: (0, global_1.getCharacter)(ids++),
    markdown: (0, global_1.getCharacter)(ids++),
    bluekeys: (0, global_1.getCharacter)(ids++),
    customkeys: (0, global_1.getCharacter)(ids++),
    greenkeys: (0, global_1.getCharacter)(ids++),
    pinkkeys: (0, global_1.getCharacter)(ids++),
    yellowkeys: (0, global_1.getCharacter)(ids++),
    varkeys: (0, global_1.getCharacter)(ids++),
    methodkeys: (0, global_1.getCharacter)(ids++),
    text: (0, global_1.getCharacter)(ids++),
    jsx: (0, global_1.getCharacter)(ids++),
    jsxJS: (0, global_1.getCharacter)(ids++),
    markdownJS: (0, global_1.getCharacter)(ids++),
    Chars: {
        ls: (0, global_1.getCharacter)(ids++),
        gt: (0, global_1.getCharacter)(ids++),
        lslash: (0, global_1.getCharacter)(ids++),
    },
    pathID: (0, global_1.getCharacter)(ids++)
};
exports.ls = (_a = exports.replacerIdentifiers.Chars, _a.ls), exports.gt = _a.gt, exports.lslash = _a.lslash;
exports.nonBreakingCharacters = {
    all: [
        ';', ':', '{', '}', '(', ')', '[', ']', ',', '<', '>', '+', '-', '*', '/', '|', '&', '^', '%', '!', '~', '?', '=', '\\s', '.'
    ],
    start: [
        ';', ':', '{', '(', ',', '[', '<', '>', '+', '-', '*', '/', '|', '&', '%', '!', '~', '?', '=', '\\s'
    ],
    end: [
        ';', '}', '(', ',', ']', '<', '>', '+', '-', '*', '/', '|', '&', '%', '!', '~', '?', '=', '\\s', '.'
    ],
};
exports.blueKeywords = {
    // JavaScript keywords
    keys: [
        //'class',
        'const',
        'debugger',
        'delete',
        'enum',
        'extends',
        'function',
        'implements',
        'interface',
        'private',
        'public',
        'super',
        'yield',
        'let',
        'var',
        'void',
        'with',
        'typeof',
        'instanceof',
        'new',
        'this',
        'true',
        'false',
        'null',
        'undefined',
        'NaN',
        'Infinity',
        'arguments',
        'in',
        'of',
        'get',
        'set',
        'async',
    ],
    pattern: function () {
        var keys = __spreadArray(__spreadArray([], this.keys, true), ['class'], false);
        var startingPattern = "(?<!\\S)\\b(".concat(keys.join('|'), ")\\b|((?<=").concat(exports.nonBreakingCharacters.start.map(global_1.excapeRegexChars).join('|'), ")\\b(").concat(keys.join('|'), ")\\b)");
        var pattern = "(".concat(startingPattern, ")(?!=\\S)|(").concat(startingPattern, ")(?=").concat(exports.nonBreakingCharacters.end.map(global_1.excapeRegexChars).join('|'), ")");
        this.pattern = new RegExp(pattern, 'gs');
    },
    classname: 'blue-keyword'
};
exports.blueKeywords.pattern();
exports.pinkKeywords = {
    // JavaScript keywords
    keys: [
        'await',
        'break',
        'case',
        'case:',
        'catch',
        'continue',
        'export',
        'as',
        'default',
        'from',
        'finally',
        'while',
        'do',
        'else',
        'if',
        'return',
        'switch',
        'throw',
        'try',
        'for',
        'import',
    ],
    pattern: function () {
        var startingPattern = "(?<!\\S)\\b(".concat(this.keys.join('|'), ")\\b|((?<=").concat(exports.nonBreakingCharacters.start.map(global_1.excapeRegexChars).join('|'), ")\\b(").concat(this.keys.join('|'), ")\\b)");
        var pattern = "(".concat(startingPattern, ")(?!=\\S)|(").concat(startingPattern, ")(?=").concat(exports.nonBreakingCharacters.end.map(global_1.excapeRegexChars).join('|'), ")");
        this.pattern = new RegExp(pattern, 'gs');
    },
    classname: 'pink-keyword'
};
exports.pinkKeywords.pattern();
exports.greenVariables = {
    // JavaScript pre-defined modules
    keys: [
        'Array',
        'Date',
        'RegExp',
        'Promise',
        'Set',
        'Map',
        'WeakSet',
        'WeakMap',
        'Function',
        'Boolean',
        'String',
        'Number',
        'Symbol',
        'Object',
        'Element',
        'Node',
        'Document',
        'Window',
        'Math',
        'JSON',
    ],
    pattern: function () {
        var startingPattern = "(?<!\\S)\\b(".concat(this.keys.join('|'), ")\\b|((?<=").concat(exports.nonBreakingCharacters.start.map(global_1.excapeRegexChars).join('|'), ")\\b(").concat(this.keys.join('|'), ")\\b)");
        var pattern = "(".concat(startingPattern, ")(?!=\\S)|(").concat(startingPattern, ")(?=").concat(exports.nonBreakingCharacters.end.map(global_1.excapeRegexChars).join('|'), ")");
        this.pattern = new RegExp(pattern, 'gs');
    },
    classname: 'green-keyword'
};
exports.greenVariables.pattern();
exports.methodVariables = {
    // JavaScript variables ^(?!y$)x$
    keys: '[a-zA-Z\\$_][0-9a-zA-Z\\$_]*',
    pattern: function () {
        var startingPattern = "(?<!\\S)\\b(".concat(this.keys, ")\\b|((?<=").concat(exports.nonBreakingCharacters.start.map(global_1.excapeRegexChars).join('|'), "|").concat((0, global_1.excapeRegexChars)('.'), ")\\b(").concat(this.keys, ")\\b)");
        var pattern = "(".concat(startingPattern, ")(?=\\s*\\()");
        this.pattern = new RegExp(pattern, 'gs');
    },
    classname: 'yellow-keyword'
};
exports.methodVariables.pattern();
exports.jsVariables = {
    // JavaScript variables
    keys: '[a-zA-Z\\$_][0-9a-zA-Z\\$_]*',
    pattern: function () {
        var startingPattern = "(?<!\\S)\\b(".concat(this.keys, ")\\b|((?<=").concat(exports.nonBreakingCharacters.start.map(global_1.excapeRegexChars).join('|'), "|").concat((0, global_1.excapeRegexChars)('.'), ")\\b(").concat(this.keys, ")\\b)");
        var pattern = "(".concat(startingPattern, ")(?!=\\S)|(").concat(startingPattern, ")(?=").concat(exports.nonBreakingCharacters.end.map(global_1.excapeRegexChars).join('|'), ")");
        this.pattern = new RegExp(pattern, 'gs');
    },
    classname: 'cyan-keyword'
};
exports.jsVariables.pattern();
exports.htmltagsExtendsBluekeys = {
    // HTML tags
    keys: [
        'a', 'abbr', 'acronym', 'address', 'applet', 'area', 'article', 'aside', 'audio', 'b', 'base', 'basefont', 'bdi', 'bdo', 'big', 'blockquote', 'body', 'br', 'button', 'canvas', 'caption', 'center',
        'cite', 'code', 'col', 'colgroup', 'data', 'datalist', 'dd', 'del', 'details', 'dfn', 'dialog', 'dir', 'div', 'dl', 'dt', 'em', 'embed', 'fieldset', 'figcaption', 'figure', 'font', 'footer', 'form',
        'frame', 'frameset', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'head', 'header', 'hr', 'html', 'i', 'iframe', 'img', 'input', 'ins', 'kbd', 'label', 'legend', 'li', 'link', 'main', 'map', 'mark', 'meta', 'meter', 'nav', 'noframes',
        'noscript', 'object', 'ol', 'optgroup', 'option', 'output', 'p', 'param', 'picture', 'pre', 'progress', 'q', 'rp', 'rt', 'ruby', 's', 'samp', 'script', 'section', 'select', 'small', 'source',
        'span', 'strike', 'strong', 'style', 'sub', 'summary', 'sup', 'svg', 'table', 'tbody', 'td', 'template', 'textarea', 'tfoot', 'th', 'thead', 'time', 'title', 'tr', 'track', 'tt', 'u', 'ul',
        'var', 'video', 'wbr'
    ],
    pattern: function () {
        var startingBluePattern = "(?<!\\S)\\b(".concat(exports.blueKeywords.keys.join('|'), ")\\b|((?<=").concat(exports.nonBreakingCharacters.start.map(global_1.excapeRegexChars).join('|'), ")\\b(").concat(exports.blueKeywords.keys.join('|'), ")\\b)");
        var bluePattern = "(".concat(startingBluePattern, ")(?!=\\S)|(").concat(startingBluePattern, ")(?=").concat(exports.nonBreakingCharacters.end.map(global_1.excapeRegexChars).join('|'), ")");
        var startingPattern = "((?<=".concat((0, global_1.excapeRegexChars)('<'), "|").concat((0, global_1.excapeRegexChars)('</'), "[ ]*)\\b(").concat(this.keys.join('|'), ")\\b)");
        var pattern = "(".concat(startingPattern, ")(?=\\s*").concat((0, global_1.excapeRegexChars)('>'), "|\\s*").concat((0, global_1.excapeRegexChars)('/>'), "|\\s+\\S*").concat((0, global_1.excapeRegexChars)('>'), "|\\s+\\S*").concat((0, global_1.excapeRegexChars)('/>'), ")");
        this.pattern = new RegExp("(".concat(bluePattern, ")|(").concat(pattern, ")"), 'gs');
    },
    classname: 'html-tag'
};
exports.htmltagsExtendsBluekeys.pattern();
exports.customtags = {
    // Custom tags
    keys: '[A-Z\\$][0-9a-zA-Z\\$_]*',
    pattern: function () {
        var startingPattern = "((?<=".concat((0, global_1.excapeRegexChars)('<'), "|").concat((0, global_1.excapeRegexChars)('</'), "[ ]*)\\b(").concat(this.keys, ")\\b)");
        var pattern = "(".concat(startingPattern, ")(?=\\s*").concat((0, global_1.excapeRegexChars)('>'), "|\\s*").concat((0, global_1.excapeRegexChars)('/>'), "|\\s+\\S*").concat((0, global_1.excapeRegexChars)('>'), "|\\s+\\S*").concat((0, global_1.excapeRegexChars)('/>'), ")");
        this.pattern = new RegExp("".concat(pattern), 'gs');
    },
    classname: 'html-tag'
};
exports.customtags.pattern();
