"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReplaceToken = exports.RemoveToken = exports.write = exports.getReplacer = void 0;
var constants_1 = require("./constants");
var patterns_1 = require("./patterns");
var rand = "".concat(Math.random()).replace('.', '');
function getReplacer(name) {
    return "".concat(constants_1.replacerIdentifiers[name]).concat(rand, "_");
}
exports.getReplacer = getReplacer;
function write(code) {
    var writes = code.match(patterns_1.writePattern);
    if (!writes)
        return code;
    var word, length;
    for (var i = 0; i < writes.length; i++) {
        word = writes[i];
        length = word.length;
        word = word.replace(/\/\/[ ]+\\write[ ]+/, '');
        if (/(\s+\\n\s*\n\s*\S)$/.test(word)) {
            code = code.replace(writes[i], word.split('\\n').join(''));
        }
        else {
            word = word.replace(/(\s*\n\s*\S)$/, '');
            code = code.replace(writes[i], "".concat(word, " ").concat(writes[i][length - 1]));
        }
    }
    return code;
}
exports.write = write;
function RemoveToken(name, code, pattern) {
    var _a;
    var matches = code.match(pattern);
    var replacer = getReplacer(name);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            code = code.replace(matches[i], "".concat(replacer).concat(i).concat(replacer));
        }
        if (name == 'text') {
            matches = matches.join(replacer).replace(/<x-text>/gs, '').replace(/<\/x-text>/gs, '').split(replacer);
        }
    }
    else {
        matches = [];
    }
    var data = (_a = { code: code }, _a[name] = matches, _a);
    return data;
}
exports.RemoveToken = RemoveToken;
function ReplaceToken(name, classname, code, tokens) {
    var replacer = getReplacer(name);
    for (var i = 0; i < tokens.length; i++) {
        code = code.replace("".concat(replacer).concat(i).concat(replacer), "".concat(constants_1.ls, "span class=\"xmk-").concat(classname, "\"").concat(constants_1.gt).concat(tokens[i]).concat(constants_1.lslash, "span").concat(constants_1.gt));
    }
    return code;
}
exports.ReplaceToken = ReplaceToken;
