"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseMarkdown = void 0;
var fs_1 = require("fs");
var path_1 = require("path");
var helper_1 = require("../helper");
var patterns_1 = require("../patterns");
var constants_1 = require("../constants");
var jsx_1 = require("./jsx");
var js_1 = require("./js");
function parseMarkdown(maincode, relativeDirectory) {
    var data = (0, helper_1.RemoveToken)('markdownJS', maincode, patterns_1.xmarkdownPattern);
    maincode = data.code;
    var markdownJS = data.markdownJS;
    var markdown = [];
    var replacer = (0, helper_1.getReplacer)('string');
    var markdownCode;
    for (var i = 0; i < markdownJS.length; i++) {
        markdownCode = markdownJS[i].replace(/\n\t|\n  /gs, '\n');
        data = (0, helper_1.RemoveToken)('jsx', markdownCode, patterns_1.xjsxPattern);
        markdown.push({
            jsx: data.jsx,
            code: data.code,
            JS: [],
            jsxCode: ''
        });
    }
    var levelJS, j, lenth, parsedJS;
    var levelJSX, levelCode;
    var pathCode = '', srcPath = '';
    for (var i = 0; i < markdown.length; i++) {
        levelJSX = markdown[i].jsx;
        srcPath = pathCode = '';
        var startPattern = /\s*\/\/<x-jsx>\s*\n/;
        var endPattern = /\s*\/\/<\/x-jsx>\s*\n/;
        replacer = (0, helper_1.getReplacer)('jsxJS');
        for (j = 0; j < levelJSX.length; j++) {
            levelJSX[j] = levelJSX[j].replace(startPattern, '').replace(endPattern, '');
            levelJSX[j] = (0, jsx_1.parseJSX)(levelJSX[j]);
            data = (0, helper_1.RemoveToken)('jsxJS', levelJSX[j], patterns_1.xjsxJSPattern);
            lenth = data.jsxJS.length;
            for (var k = 0; k < lenth; k++) {
                parsedJS = (0, js_1.parseJSOnly)(data.jsxJS[k]);
                levelJSX[j] = levelJSX[j].replace("".concat(replacer).concat(k).concat(replacer), "".concat(constants_1.ls, "div class=\"xmk-js2x\"").concat(constants_1.gt).concat(parsedJS).concat(constants_1.lslash, "div").concat(constants_1.gt));
            }
        }
        startPattern = /\/\/<xyntax\s+path\s*=\s*('\S+'|"\S+")\s+[a-zA-Z-0-9\$_]+>\s*{/;
        endPattern = /}\s*\/\/<\/xyntax>/;
        levelCode = markdown[i].code;
        var markdownId = levelCode.match(/\/\/<xyntax\s+path\s*=\s*('\S+'|"\S+")\s+[a-zA-Z-0-9\$_]+>/gs)[0];
        markdownId = markdownId.replace(/\/\/<xyntax\s+path\s*=\s*('|")/, '').replace(/>$/, '').split(/\s+/);
        var writeToFilePath = markdownId[0].replace(/('|")$/, '');
        markdownId = markdownId[1];
        levelCode = levelCode.replace(startPattern, ' ').replace(endPattern, ' ');
        levelCode = (0, js_1.parseJSOnly)(levelCode);
        replacer = (0, helper_1.getReplacer)('jsx');
        lenth = levelJSX.length;
        for (var k = 0; k < lenth; k++) {
            levelCode = levelCode.replace("".concat(replacer).concat(k).concat(replacer), "".concat(constants_1.ls, "div class=\"xmk-jsx\"").concat(constants_1.gt).concat(levelJSX[k]).concat(constants_1.lslash, "div").concat(constants_1.gt));
        }
        levelCode = "".concat(constants_1.ls, "div class=\"xmk-js1x\"").concat(constants_1.gt).concat(levelCode).concat(constants_1.lslash, "div").concat(constants_1.gt);
        levelCode = levelCode.replace(/&/gs, '&#38').replace(/</gs, '&#60;').replace(/>/gs, '&#62;')
            .replace(/\//gs, '&#47;').replace(/\{/gs, '&#123;').replace(/\}/gs, '&#125;').replace(/`/gs, '&#96;')
            .replace(RegExp("".concat(constants_1.ls), 'gs'), '<').replace(RegExp("".concat(constants_1.lslash), 'gs'), '</').replace(RegExp("".concat(constants_1.gt), 'gs'), '>');
        markdown[i] = '';
        replacer = (0, helper_1.getReplacer)('markdownJS');
        maincode = maincode.replace("".concat(replacer).concat(i).concat(replacer), '\n');
        srcPath = (0, path_1.resolve)(relativeDirectory, writeToFilePath);
        pathCode = (0, fs_1.readFileSync)(srcPath, 'utf8');
        replacer = (0, helper_1.getReplacer)('pathID');
        var allToReplace = pathCode.match(RegExp("(?<!\\\\)`[\\s\\S]*?(?<!\\\\)`\\s*;*\\s*\\/\\/[ ]*\\\\insert[ ]+" + markdownId, 'gs'));
        if (!allToReplace) {
            continue;
        }
        pathCode = pathCode.replace(RegExp("(?<!\\\\)`[\\s\\S]*?(?<!\\\\)`\\s*;*\\s*\\/\\/[ ]*\\\\insert[ ]+" + markdownId, 'gs'), replacer);
        for (var i_1 = 0; i_1 < allToReplace.length; i_1++) {
            pathCode = pathCode.replace(replacer, "`".concat(levelCode, "`; // \\insert ").concat(markdownId, " "));
        }
        (0, fs_1.writeFileSync)(srcPath, pathCode);
    }
    return maincode;
}
exports.parseMarkdown = parseMarkdown;
