"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseJSOnly = void 0;
var constants_1 = require("../constants");
var helper_1 = require("../helper");
var patterns_1 = require("../patterns");
function parseJSOnly(maincode) {
    var data = (0, helper_1.RemoveToken)('string', maincode, patterns_1.stringsPattern);
    var strings = data.string;
    data = (0, helper_1.RemoveToken)('comment', (0, helper_1.write)(data.code), patterns_1.commentsPattern);
    var comments = data.comment;
    data = (0, helper_1.RemoveToken)('bluekeys', data.code, constants_1.htmltagsExtendsBluekeys.pattern);
    var bluekeys = data.bluekeys;
    data = (0, helper_1.RemoveToken)('customkeys', data.code, constants_1.customtags.pattern);
    var customtagkeys = data.customkeys;
    data = (0, helper_1.RemoveToken)('pinkkeys', data.code, constants_1.pinkKeywords.pattern);
    var pinkkeys = data.pinkkeys;
    data = (0, helper_1.RemoveToken)('greenkeys', data.code, constants_1.greenVariables.pattern);
    var greenkeys = data.greenkeys;
    data = (0, helper_1.RemoveToken)('yellowkeys', data.code, constants_1.methodVariables.pattern);
    var yellowkeys = data.yellowkeys;
    data = (0, helper_1.RemoveToken)('varkeys', data.code, constants_1.jsVariables.pattern);
    var varkeys = data.varkeys;
    var code = data.code;
    data = null;
    code =
        (0, helper_1.ReplaceToken)('comment', 'commentx', (0, helper_1.ReplaceToken)('string', 'stringx', (0, helper_1.ReplaceToken)('bluekeys', 'key1x', (0, helper_1.ReplaceToken)('customkeys', 'predefx', (0, helper_1.ReplaceToken)('pinkkeys', 'key2x', (0, helper_1.ReplaceToken)('greenkeys', 'predefx', (0, helper_1.ReplaceToken)('yellowkeys', 'methx', (0, helper_1.ReplaceToken)('varkeys', 'varx', code, varkeys), yellowkeys), greenkeys), pinkkeys), customtagkeys), bluekeys), strings), comments);
    return code;
}
exports.parseJSOnly = parseJSOnly;
