"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseFile = void 0;
var fs_1 = require("fs");
var path_1 = require("path");
var index_1 = require("../index");
function parseDirectory(srcDir, rootDir) {
    var srcDirContent;
    try {
        srcDirContent = (0, fs_1.readdirSync)(srcDir, { encoding: 'utf8' });
    }
    catch (error) {
        return false;
    }
    for (var i = 0; i < srcDirContent.length; i++) {
        parseFile((0, path_1.join)(srcDir, '/', srcDirContent[i]), rootDir);
    }
    return true;
}
function parseFile(srcFile, rootDir) {
    if (!parseDirectory(srcFile, rootDir)) {
        if (/(\.xmd\.[a-zA-Z]+)$/.test(srcFile)) {
            (0, index_1.ParseString)((0, fs_1.readFileSync)(srcFile, 'utf8'), rootDir);
        }
    }
}
exports.parseFile = parseFile;
